package com.copy.trade.bean;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.time.Duration;

/**
 * redis分布式锁工具类
 */
@Component
@Slf4j
public class RedisLock {

    @Autowired
    private StringRedisTemplate stringRedisTemplate;


    /**
     * 加锁
     * @param key
     * @param value
     * @return
     */
    public boolean lock(String key,String value){

        int loop = 5;
        while (loop > 0){
            if(stringRedisTemplate.opsForValue().setIfAbsent(key, value)){//对应setnx命令
                //可以成功设置,也就是key不存在
                return true;
            }
            if(stringRedisTemplate.opsForValue().get(key) == null){
                stringRedisTemplate.delete(key);
                //stringRedisTemplate.opsForValue().getOperations().delete(key);
                if(stringRedisTemplate.opsForValue().setIfAbsent(key,value)){//对应setnx命令
                    //可以成功设置,也就是key不存在
                    return true;
                }
            }

            //判断锁超时 - 防止原来的操作异常，没有运行解锁操作  防止死锁
            String currentValue = stringRedisTemplate.opsForValue().get(key);
            //如果锁过期
            if(!StringUtils.isEmpty(currentValue)){
                //获取上一个锁的value
                String oldValue =stringRedisTemplate.opsForValue().getAndSet(key,value);//对应getset，如果key存在

                //假设两个线程同时进来这里，因为key被占用了，而且锁过期了。获取的值currentValue=A(get取的旧的值肯定是一样的),两个线程的value都是B,key都是K.锁时间已经过期了。
                //而这里面的getAndSet一次只会一个执行，也就是一个执行之后，上一个的value已经变成了B。只有一个线程获取的上一个值会是A，另一个线程拿到的值是B。
                if(!StringUtils.isEmpty(oldValue) && oldValue.equals(currentValue) ){
                    //oldValue不为空且oldValue等于currentValue，防止并发
                    return true;
                }
            }
            try {
                Thread.sleep(200);
            }catch (Exception e){
                log.error("获取redis锁等待异常:",e);
            }

            loop--;
        }
        return false;
    }

    /**
     * 加锁
     * @param key
     * @param value
     * @Param time 过期时间(毫秒)
     * @return
     */
    public boolean lock(String key,String value,long time){
        int loop = 5;
        while (loop > 0) {
            if (stringRedisTemplate.opsForValue().setIfAbsent(key, value, Duration.ofMillis(time))) {//对应setnx命令
                //可以成功设置,也就是key不存在
                return true;
            }
            if (stringRedisTemplate.opsForValue().get(key) == null) {
                stringRedisTemplate.delete(key);
                //stringRedisTemplate.opsForValue().getOperations().delete(key);
                if (stringRedisTemplate.opsForValue().setIfAbsent(key, value, Duration.ofMillis(time))) {//对应setnx命令
                    //可以成功设置,也就是key不存在
                    return true;
                }
            }
            try {
                Thread.sleep(100);
            }catch (Exception e){
                log.error("获取redis锁等待异常:",e);
            }
            loop--;
        }
        return false;
    }


    /**
     * 解锁
     * @param key
     * @param value
     */
    public void unlock(String key,String value){
        try {
            String currentValue = stringRedisTemplate.opsForValue().get(key);
            if(!StringUtils.isEmpty(currentValue) && currentValue.equals(value) ){
                 //stringRedisTemplate.opsForValue().getOperations().delete(key);//删除key
                stringRedisTemplate.delete(key);
            }
        } catch (Exception e) {
            log.error("[Redis分布式锁] 解锁出现异常了，{}",e);
        }
    }

}
